using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Baza_Reklam
{
    public partial class ZestawienieZamowienForm : Form
    {
        string query = "SELECT top 2000 * from VIEW_ZESTAWIENIE_ZAMOWIEN_NOWE ";

        private static ZestawienieZamowienForm form;
        private SqlCommand command;
        private SqlDataAdapter sqlDataAdapter = new SqlDataAdapter();

        private bool commandExecuted = false;

        public static ZestawienieZamowienForm getZestawienieZamowienForm(MDIBazaReklam parent)
        {
            if (form == null){
                form = new ZestawienieZamowienForm(parent);
            }
            return form;
        }

        private ZestawienieZamowienForm(MDIBazaReklam parent)
        {
            InitializeComponent();

            this.MdiParent = parent;

            //podmiana connstringa
            this.VIEW_ZESTAWIENIE_ZAMOWIEN_NOWETableAdapter.Connection.ConnectionString = ConnString.getConnString().Value;
            this.reklamyZestawienieTableAdapter.Connection.ConnectionString = ConnString.getConnString().Value;
            
            //obiekty wykorzytywane przy wyszukiwaniu
            SqlConnection conn = new SqlConnection(ConnString.getConnString().Value);
           
            command = new SqlCommand(query,conn);
          
            //generuje piersze węzły w drzewie
            generateNodes();
       }

        private void FacturesForm_Load(object sender, EventArgs e)
        {
            this.WindowState = FormWindowState.Maximized;
            command.CommandText = this.query;
            sqlDataAdapter.SelectCommand = command;

            DBBindings.bindujAgencje(agencjaToolStripComboBox);
        }

        private void generateNodes()
        {
            TreeNode node;

            node = new TreeNode("Biura");
            node.Nodes.Add(new TreeNode());
            node.Name = "Biura";
            treeView1.Nodes.Add(node);

            command.Connection.Close();                         
        }

        private void treeView1_AfterSelect(object sender, TreeViewEventArgs e)
        {
            if (e.Node != null)
            {
                command.CommandText = query;
                command.Parameters.Clear();

                switch (e.Node.Level)
                {
                    case 0:
                        break;
                    case 1:
                        break;
                    case 2:
                        break;
                    case 3:
                        switch (e.Node.Parent.Parent.Parent.Name)
                        {
                            case "Biura":

                                this.Cursor = Cursors.WaitCursor;
                                
                                rEKLAMADataSet.VIEW_ZESTAWIENIE_ZAMOWIEN_NOWE.Clear();
                                command.CommandText += " where agent=@agent";
                                command.Parameters.AddWithValue("@agent", e.Node.Name);
                                sqlDataAdapter.Fill(this.rEKLAMADataSet.VIEW_ZESTAWIENIE_ZAMOWIEN_NOWE);
                                commandExecuted = true;
                                fakturyDataGridView.Refresh();

                                this.Cursor = Cursors.Default;

                                break;
                            default:
                                break;
                        }
                        break;
                    case 4:
                        break;
                    default:
                        break;
                }           
                }  
        }

        private void treeView1_AfterExpand(object sender, TreeViewEventArgs e)
        {
            TreeNode node;
            SqlDataReader reader;

            if (e.Node != null)
            {
               switch (e.Node.Level)
                {
                    case 0:
                        switch (e.Node.Name)
                        {
                            case "Biura":
                                DBBindings.dodajAgencjeDoWezla(e.Node);
                                break;
                        }  
                        break;
                    case 1:
                        switch (e.Node.Parent.Name)
                        {
                            case "Biura":
                                e.Node.Nodes.Clear();

                                node = new TreeNode("Agenci");
                                node.Name = "Agenci";
                                e.Node.Nodes.Add(node);
                                DBBindings.dodajAgentowDoWezla(node, e.Node.Name);
                                break;
                        }
                        break;
                    default:
                        break;
                }
            }
        }
       
        private void wyszukajToolStripButton_Click(object sender, EventArgs e)
        {
            wyszukajToolStrip.Visible = wyszukajToolStrip.Visible ? false : true;
        }

    
        private void fakturyDataGridView_Leave(object sender, EventArgs e)
        {
            fakturyDataGridView.EndEdit();
        }
        private void zestawienieFakturBindingSource_ListChanged(object sender, ListChangedEventArgs e)
        {          
          
        }

        private void toolStripButton1_Click(object sender, EventArgs e)
        {
            PrintDGV.Print_DataGridView(fakturyDataGridView,50);
        }

        private void wyczyscPolaToolStripButton_Click(object sender, EventArgs e)
        {
            nrZamToolStripTextBox.Clear();
            agencjaToolStripComboBox.SelectedIndex = -1;
            kodKlientaToolStripTextBox.Clear();
            rokToolStripTextBox.Clear();
            kodRozliczeniowyToolStripTextBox.Clear();
         }

        /// <summary>
        /// Przechodzi do okna KLIENCI i wyświetla dane klienta związanego z  fakturą.
        /// </summary>
        private void klientToolStripButton_Click(object sender, EventArgs e)
        {

            if (VIEW_ZESTAWIENIE_ZAMOWIEN_NOWEBindingSource.Current != null)
            {
                DataRowView row = (DataRowView)VIEW_ZESTAWIENIE_ZAMOWIEN_NOWEBindingSource.Current;

                int custID = Convert.ToInt32(row["idKlienta"]);

                ClientsForm.getClientsForm((MDIBazaReklam)this.MdiParent).pokazKlienta(custID);

                this.Hide();

                ClientsForm.getClientsForm((MDIBazaReklam)this.MdiParent).Show();

            }   
        }

        private void FacturesForm_Shown(object sender, EventArgs e)
        {
            rokToolStripTextBox.Text = DateTime.Today.Year.ToString();
          
            if (User.getUser().St_kierownik)
            {
               agencjaToolStripComboBox.Text = User.getUser().SymbolAgencji;
            }
            else if (User.getUser().St_handlowiec | User.getUser().St_subhandlowiec)
            {
               kodRozliczeniowyToolStripTextBox.Text = User.getUser().Kod_agenta;
            }            
        }

        private void excelToolStripButton_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;

            ExcelHandler ex = new ExcelHandler();
            ex.exportToExcel(fakturyDataGridView);

            this.Cursor = Cursors.Default;
        }

        private void VIEW_ZESTAWIENIE_ZAMOWIEN_NOWEBindingSource_CurrentChanged(object sender, EventArgs e)
        {
            DataRowView row = (DataRowView)VIEW_ZESTAWIENIE_ZAMOWIEN_NOWEBindingSource.Current;
            REKLAMADataSet.VIEW_ZESTAWIENIE_ZAMOWIEN_NOWERow zam =
                (REKLAMADataSet.VIEW_ZESTAWIENIE_ZAMOWIEN_NOWERow)row.Row;

            this.reklamyZestawienieTableAdapter.FillByIdZamowienia(
                this.rEKLAMADataSet.ReklamyZestawienie,zam.idZamowienia);

        }

        private void zamowieniaToolStripButton_Click(object sender, EventArgs e)
        {
            if (VIEW_ZESTAWIENIE_ZAMOWIEN_NOWEBindingSource.Current != null)
            {
                DataRowView row = (DataRowView)VIEW_ZESTAWIENIE_ZAMOWIEN_NOWEBindingSource.Current;

                REKLAMADataSet.VIEW_ZESTAWIENIE_ZAMOWIEN_NOWERow zam =
                (REKLAMADataSet.VIEW_ZESTAWIENIE_ZAMOWIEN_NOWERow)row.Row;

                ZamowieniaForm zf = new ZamowieniaForm(zam.idKlienta,zam.idZamowienia);
                zf.ShowDialog();
            }
        }

        private void odswiezToolStripButton_Click(object sender, EventArgs e)
        {
            if (commandExecuted)
            {
                this.Cursor = Cursors.WaitCursor;

                rEKLAMADataSet.VIEW_ZESTAWIENIE_ZAMOWIEN_NOWE.Clear();
                sqlDataAdapter.Fill(this.rEKLAMADataSet.VIEW_ZESTAWIENIE_ZAMOWIEN_NOWE);
                fakturyDataGridView.Refresh();

                this.Cursor = Cursors.Default;
            }
        }

        private void zamToolStripButton_Click(object sender, EventArgs e)
        {

            if (reklamyZestawienieBindingSource.Current != null)
            {
                DataRowView row = (DataRowView)reklamyZestawienieBindingSource.Current;

                if (row["reklamaId"] != DBNull.Value)
                {
                    int idRek = Convert.ToInt32(row["reklamaId"]);

                    OrderDetails.getOrderDetails().pokazSzczegolyZamowienia(idRek);
                    OrderDetails.getOrderDetails().ShowDialog();
                }
            }

        }

        private void szukajToolStripButton_Click(object sender, EventArgs e)
        {
            command.CommandText = query;

            this.rEKLAMADataSet.VIEW_ZESTAWIENIE_ZAMOWIEN_NOWE.Clear();
            this.rEKLAMADataSet.ReklamyZestawienie.Clear();

            command.CommandText += " where 1=1 ";

            command.Parameters.Clear();
                      
            if (nrZamToolStripTextBox.Text.Trim() != "")
            {
                int i;
                if (!Int32.TryParse(nrZamToolStripTextBox.Text.Trim(), out i))
                {
                    MessageBox.Show("Podaj prawidłowy numer zamówienia.");
                    return;
                }

                command.CommandText += " AND nrZamowienia=@nr";
                command.Parameters.AddWithValue("@nr", nrZamToolStripTextBox.Text.Trim());
            }
                     
            if (rokToolStripTextBox.Text.Trim() != "")
            {
                int i;
                if (!Int32.TryParse(rokToolStripTextBox.Text.Trim(), out i))
                {
                    MessageBox.Show("Podaj prawidłowy rok.");
                    return;
                }

                command.CommandText += " AND rokZamowienia=@rok";
                command.Parameters.AddWithValue("@rok", rokToolStripTextBox.Text.Trim());
            }
                        
            if (kodRozliczeniowyToolStripTextBox.Text.Trim() != "")
            {
                command.CommandText += " AND kodAgenta = @kod ";
                command.Parameters.AddWithValue("@kod", kodRozliczeniowyToolStripTextBox.Text.Trim());
            }

            if (kodKlientaToolStripTextBox.Text.Trim() != "")
            {
                command.CommandText += " AND kodKlienta like '%' + @kodKlienta + '%'";
                command.Parameters.AddWithValue("@kodKlienta", kodKlientaToolStripTextBox.Text.Trim());
            }

            if (agencjaToolStripComboBox.Text.Trim() != "")
            {
                command.CommandText += " AND Agencja=@agencja";
                command.Parameters.AddWithValue("@agencja", agencjaToolStripComboBox.Text.Trim());
            }

            sqlDataAdapter.SelectCommand = command;

            this.Cursor = Cursors.WaitCursor;

            try
            {
                int t = sqlDataAdapter.Fill(this.rEKLAMADataSet.VIEW_ZESTAWIENIE_ZAMOWIEN_NOWE);
                commandExecuted = true;
            }
            catch (Exception e1)
            {
                MessageBox.Show(e1.Message);
            }

            treeView1.CollapseAll();
            treeView1.SelectedNode = null;

            this.Cursor = Cursors.Default;
        }

    }
}